/*  Package GeoTools/WMS Implementation
 *  Copyright (C) 2001 Cameron Shorter (camerons@users.sourceforge.net)
 *                     Artur Hefczyc (kobit@users.sourceforge.net)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: BBox.java,v 1.3 2001/10/24 09:40:18 kobit Exp $
 * $Date: 2001/10/24 09:40:18 $
 * $Author: kobit $
 */

package uk.ac.leeds.ccg.ogc;

/**
 * Describe class <code>BBox</code> here.
 *
 * @author <a href="mailto:camerons@users.sourceforge.net">Cameron Shorter</a>
 * @author <a href="mailto:kobit@users.sourceforge.net">Artur Hefczyc</a>
 * @version $Revision: 1.3 $
 */
public class BBox
{

  protected String srs = null;

  protected double maxx = 0;
  protected double maxy = 0;
  protected double minx = 0;
  protected double miny = 0;

  public BBox(){}

  public BBox(String srs,
                    double maxx, double maxy, double minx, double miny) {
    this.srs = srs;
    this.maxx = maxx;
    this.maxy = maxy;
    this.minx = minx;
    this.miny = miny;
  }

  /**
   * Get the value of maxx.
   * @return value of maxx.
   */
  public double getMaxx() {
    return maxx;
  }
  
  /**
   * Set the value of maxx.
   * @param v  Value to assign to maxx.
   */
  public void setMaxx(double  v) {
    this.maxx = v;
  }
  
  /**
   * Get the value of maxy.
   * @return value of maxy.
   */
  public double getMaxy() {
    return maxy;
  }
  
  /**
   * Set the value of maxy.
   * @param v  Value to assign to maxy.
   */
  public void setMaxy(double  v) {
    this.maxy = v;
  }

  /**
   * Get the value of minx.
   * @return value of minx.
   */
  public double getMinx() {
    return minx;
  }
  
  /**
   * Set the value of minx.
   * @param v  Value to assign to minx.
   */
  public void setMinx(double  v) {
    this.minx = v;
  }

  /**
   * Get the value of miny.
   * @return value of miny.
   */
  public double getMiny() {
    return miny;
  }
  
  /**
   * Set the value of miny.
   * @param v  Value to assign to miny.
   */
  public void setMiny(double  v) {
    this.miny = v;
  }
  
}
/*
 * Changes in file:
 *
 * $Log: BBox.java,v $
 * Revision 1.3  2001/10/24 09:40:18  kobit
 * Added LOG cvs keyword to the end of file
 *
 *
 */
