/*  Package GeoTools/WMS Implementation
 *  Copyright (C) 2001 Cameron Shorter (camerons@users.sourceforge.net)
 *                     Artur Hefczyc (kobit@users.sourceforge.net)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: OGCXMLConstants.java,v 1.7 2002/01/31 10:16:58 ianturton Exp $
 * $Author: ianturton $
 * $Date: 2002/01/31 10:16:58 $
 */

package uk.ac.leeds.ccg.ogc;

/**
 * Class <code>OGCXMLConstants</code> contains <code>String</code> constants
 * representing different elememts of <code>WMS</code> capabilities such
 * as <em>tag names</em>, <em>attributes names</em> and so on.
 *
 * @author <a href="mailto:camerons@users.sourceforge.net">Cameron Shorter</a>
 * @author <a href="mailto:kobit@users.sourceforge.net">Artur Hefczyc</a>
 * @version $Revision: 1.7 $
 */
public class OGCXMLConstants
{

  /* Tag names from DTD ver 1.1.0 */

  public static final String TAG_ROOT       = "WMT_MS_Capabilities";
  public static final String TAG_SERVICE    = "Service";
  public static final String TAG_CAPABILITY = "Capability";
  public static final String TAG_NAME       = "Name";
  public static final String TAG_TITLE      = "Title";
  public static final String TAG_ABSTRACT   = "Abstract";
  public static final String TAG_RESOURCE   = "OnlineResource";
  public static final String TAG_LAYER      = "Layer";
  public static final String TAG_FORMAT     = "Format";
  public static final String TAG_GIF        = "GIF";
  public static final String TAG_PNG        = "PNG";
  public static final String TAG_JPEG       = "JPEG";
  public static final String TAG_TIFF       = "TIFF";
  public static final String TAG_PPM        = "PPM";
  public static final String TAG_GML_1      ="GML.1";
  public static final String TAG_GML_2      ="GML.2";
  public static final String TAG_WMS_XML    ="WMS_XML";
  public static final String TAG_MIME       ="MIME";
  public static final String TAG_INIMAGE    ="INIMAGE";
  public static final String TAG_HTML       ="HTML";
  public static final String TAG_LAT_LON_BB = "LatLonBoundingBox";
  public static final String TAG_STYLE      = "Style";
  public static final String TAG_LEGEND_URL = "LegendURL";
  public static final String TAG_ONLINE_RES = "OnlineResource";

  /* Attributes names from DTD ver 1.1.0 */

  public static final String ATT_VERSION   = "version";
  public static final String ATT_QUERYABLE = "queryable";
  public static final String ATT_MAXX      = "maxx";
  public static final String ATT_MAXY      = "maxy";
  public static final String ATT_MINX      = "minx";
  public static final String ATT_MINY      = "miny";
  public static final String ATT_HEIGHT    = "height";
  public static final String ATT_WIDTH     = "width";
  public static final String ATT_XLNK_HREF = "xlink:href";

}
/*
 * Changes in file:
 *
 * $Log: OGCXMLConstants.java,v $
 * Revision 1.7  2002/01/31 10:16:58  ianturton
 * initial changes to support new format xml capabilities files now look like
 * <format>
 * <jpeg/>
 * <png/>
 * <gif/>
 * </format>
 *
 * - at present getFormats just returns jpeg all the time since my mastery of
 * dom parsers failed.
 *
 * Revision 1.6  2001/10/24 09:40:18  kobit
 * Added LOG cvs keyword to the end of file
 *
 *
 */
